package at.jku.students;

import at.jku.ssw.Queue;
import at.jku.ssw.Iterator;
import java.util.Arrays;

public class ArrayQueue extends Queue {

  private static final int MAX_SIZE = 20;
  private char[] queue = new char[MAX_SIZE];
  private int count, head, tail;
  
  public char get() throws Exception {
    if (count > 0) {
      char value = queue[head];
      head = (head + 1) % queue.length;
      count--;
      return value;
    } else {
      throw new Exception("Queue is empty");
    }
  }
  
  public void put(char value) throws Exception {
    if (count == queue.length) {
      throw new Exception("Queue is full");
    }
    queue[tail] = value;
    tail = (tail + 1) % queue.length;
    count++;
  }

  public int size() {
    return count;
  }

  public Iterator iterator() {
    return new ArrayQueueIterator(Arrays.copyOf(queue, queue.length), head, count);
  }
  
}